<?php
/**
 * ProgressMaker allows to dynamic build Progress bar,
 * give a shot on display, and get CSS generated.
 * 
 * @version    $Id: ProgressMaker.php,v 1.2 2003/09/24 22:16:43 Farell Exp $
 * @author     Laurent Laville <pear@laurent-laville.org>
 * @package    HTML_Progress
 */

require_once 'HTML/Progress.php';

require_once 'HTML/QuickForm/Controller.php';

// Load some default action handlers
require_once 'HTML/QuickForm/Action/Submit.php';
require_once 'HTML/QuickForm/Action/Jump.php';
require_once 'HTML/QuickForm/Action/Display.php';
require_once 'HTML/QuickForm/Action/Direct.php';


/**
 *  Global properties
 */
class Property1 extends HTML_QuickForm_Page
{
    function buildForm()
    {
        $this->_formBuilt = true;

        $tabs[] =& $this->createElement('submit', $this->getButtonName('page1'), 'Shape', array('class' => 'flat', 'disabled' => 'disabled'));
        $tabs[] =& $this->createElement('submit', $this->getButtonName('page2'), 'Cell', array('class' => 'flat'));
        $tabs[] =& $this->createElement('submit', $this->getButtonName('page3'), 'Text', array('class' => 'flat'));
        $tabs[] =& $this->createElement('submit', $this->getButtonName('page4'), 'Message', array('class' => 'flat'));
        $tabs[] =& $this->createElement('submit', $this->getButtonName('page5'), 'Ready', array('class' => 'flat'));
        $this->addGroup($tabs, 'tabs', null, '&nbsp;', false);

        $this->addElement('header', null, 'Global aspect');

        $shape[] =& $this->createElement('radio', null, null, 'Horizontal', '1');
        $shape[] =& $this->createElement('radio', null, null, 'Vertical', '2');
        $this->addGroup($shape, 'shape', 'Progress shape:');

        $way[] =& $this->createElement('radio', null, null, 'Natural', 'natural');
        $way[] =& $this->createElement('radio', null, null, 'Reverse', 'reverse');
        $this->addGroup($way, 'way', 'Progress way:');

        $barsize['width']   =& $this->createElement('text', 'width', null, array('size' => 4));
        $barsize['height']  =& $this->createElement('text', 'height', null, array('size' => 4));
        $barsize['bgcolor'] =& $this->createElement('text', 'bgcolor', null, array('size' => 7));
        $this->addGroup($barsize, 'barsize', 'Bar size (width, height):', ',&nbsp;');


        $this->addElement('submit', $this->getButtonName('next'), 'Next >>');
    }
}

/**
 *  Cell size and color properties
 */
class Property2 extends HTML_QuickForm_Page
{
    function buildForm()
    {
        $this->_formBuilt = true;

        $tabs[] =& $this->createElement('submit', $this->getButtonName('page1'), 'Shape', array('class' => 'flat'));
        $tabs[] =& $this->createElement('submit', $this->getButtonName('page2'), 'Cell', array('class' => 'flat', 'disabled' => 'disabled'));
        $tabs[] =& $this->createElement('submit', $this->getButtonName('page3'), 'Text', array('class' => 'flat'));
        $tabs[] =& $this->createElement('submit', $this->getButtonName('page4'), 'Message', array('class' => 'flat'));
        $tabs[] =& $this->createElement('submit', $this->getButtonName('page5'), 'Ready', array('class' => 'flat'));
        $this->addGroup($tabs, 'tabs', null, '&nbsp;', false);

        $this->addElement('header', null, 'Cell size and color');

        $cellsize['width']   =& $this->createElement('text', 'width', null, array('size' => 4));
        $cellsize['height']  =& $this->createElement('text', 'height', null, array('size' => 4));
        $cellsize['spacing'] =& $this->createElement('text', 'spacing', null, array('size' => 2));
        $this->addGroup($cellsize, 'cellsize', 'Cell size (width, height, spacing):', ',&nbsp;');

        $cellcolor['active']   =& $this->createElement('text', 'active', null, array('size' => 7));
        $cellcolor['inactive'] =& $this->createElement('text', 'inactive', null, array('size' => 7));
        $this->addGroup($cellcolor, 'cellcolor', 'Cell color (active, inactive):', ',&nbsp;');

        $barborder['style'] =& $this->createElement('select', 'style', null, array('solid'=>'Solid', 'dashed'=>'Dashed', 'dotted'=>'Dotted', 'inset'=>'Inset', 'outset'=>'Outset'));
        $barborder['width'] =& $this->createElement('text', 'width', null, array('size' => 2));
        $barborder['color'] =& $this->createElement('text', 'color', null, array('size' => 7));
        $this->addGroup($barborder, 'barborder', 'Bar border (style, width, color):', ',&nbsp;');


        $prevnext[] =& $this->createElement('submit', $this->getButtonName('back'), '<< Back');
        $prevnext[] =& $this->createElement('submit', $this->getButtonName('next'), 'Next >>');
        $this->addGroup($prevnext, null, '', '&nbsp;', false);       
    }
}

/**
 *  Text (percent info) properties
 */
class Property3 extends HTML_QuickForm_Page
{
    function buildForm()
    {
        $this->_formBuilt = true;

        $tabs[] =& $this->createElement('submit', $this->getButtonName('page1'), 'Shape', array('class' => 'flat'));
        $tabs[] =& $this->createElement('submit', $this->getButtonName('page2'), 'Cell', array('class' => 'flat'));
        $tabs[] =& $this->createElement('submit', $this->getButtonName('page3'), 'Text', array('class' => 'flat', 'disabled' => 'disabled'));
        $tabs[] =& $this->createElement('submit', $this->getButtonName('page4'), 'Message', array('class' => 'flat'));
        $tabs[] =& $this->createElement('submit', $this->getButtonName('page5'), 'Ready', array('class' => 'flat'));
        $this->addGroup($tabs, 'tabs', null, '&nbsp;', false);

        $this->addElement('header', null, 'Text (percent info)');

        $textvisible[] =& $this->createElement('radio', null, null, 'Yes', true);
        $textvisible[] =& $this->createElement('radio', null, null, 'No', false);
        $this->addGroup($textvisible, 'textvisible', 'Text visible:');

        $textsize['width']   =& $this->createElement('text', 'width', null, array('size' => 4));
        $textsize['height']  =& $this->createElement('text', 'height', null, array('size' => 4));
        $this->addGroup($textsize, 'textsize', 'Text size (width, height):', ',&nbsp;');

        $textvalign[] =& $this->createElement('radio', null, null, 'Left', 'left');
        $textvalign[] =& $this->createElement('radio', null, null, 'Right', 'right');
        $textvalign[] =& $this->createElement('radio', null, null, 'Top', 'top');
        $textvalign[] =& $this->createElement('radio', null, null, 'Bottom', 'bottom');
        $this->addGroup($textvalign, 'textvalign', 'Vertical alignment:');

        $texthalign[] =& $this->createElement('radio', null, null, 'Left', 'left');
        $texthalign[] =& $this->createElement('radio', null, null, 'Right', 'right');
        $texthalign[] =& $this->createElement('radio', null, null, 'Center', 'center');
        $this->addGroup($texthalign, 'texthalign', 'Horizontal alignment:');

        $text['font']    =& $this->createElement('text', 'font', null, array('size' => 30));
        $text['size']    =& $this->createElement('text', 'size', null, array('size' => 2));
        $text['color']   =& $this->createElement('text', 'color', null, array('size' => 7));
        $text['bgcolor'] =& $this->createElement('text', 'bgcolor', null, array('size' => 7));
        $text['text']    =& $this->createElement('text', 'text', null, array('size' => 20));
        $this->addGroup($text, 'text', 'Text (font, size, color, bgcolor, legend):', ',&nbsp;');


        $prevnext[] =& $this->createElement('submit', $this->getButtonName('back'), '<< Back');
        $prevnext[] =& $this->createElement('submit', $this->getButtonName('next'), 'Next >>');
        $this->addGroup($prevnext, null, '', '&nbsp;', false);       
    }
}

/**
 *  Message line properties
 */
class Property4 extends HTML_QuickForm_Page
{
    function buildForm()
    {
        $this->_formBuilt = true;

        $tabs[] =& $this->createElement('submit', $this->getButtonName('page1'), 'Shape', array('class' => 'flat'));
        $tabs[] =& $this->createElement('submit', $this->getButtonName('page2'), 'Cell', array('class' => 'flat'));
        $tabs[] =& $this->createElement('submit', $this->getButtonName('page3'), 'Text', array('class' => 'flat'));
        $tabs[] =& $this->createElement('submit', $this->getButtonName('page4'), 'Message', array('class' => 'flat', 'disabled' => 'disabled'));
        $tabs[] =& $this->createElement('submit', $this->getButtonName('page5'), 'Ready', array('class' => 'flat'));
        $this->addGroup($tabs, 'tabs', null, '&nbsp;', false);

        $this->addElement('header', null, 'Message line');

        $msgvisible[] =& $this->createElement('radio', null, null, 'Yes', true);
        $msgvisible[] =& $this->createElement('radio', null, null, 'No', false);
        $this->addGroup($msgvisible, 'msgvisible', 'Message line visible:');

        $msgsize['width']   =& $this->createElement('text', 'width', null, array('size' => 4));
        $msgsize['height']  =& $this->createElement('text', 'height', null, array('size' => 4));
        $this->addGroup($msgsize, 'msgsize', 'Message size (width, height):', ',&nbsp;');

        $msgvalign[] =& $this->createElement('radio', null, null, 'Top', 'top');
        $msgvalign[] =& $this->createElement('radio', null, null, 'Bottom', 'bottom');
        $this->addGroup($msgvalign, 'msgvalign', 'Vertical alignment:');

        $msghalign[] =& $this->createElement('radio', null, null, 'Left', 'left');
        $msghalign[] =& $this->createElement('radio', null, null, 'Right', 'right');
        $msghalign[] =& $this->createElement('radio', null, null, 'Center', 'center');
        $this->addGroup($msghalign, 'msghalign', 'Horizontal alignment:');

        $msg['font']    =& $this->createElement('text', 'font', null, array('size' => 30));
        $msg['size']    =& $this->createElement('text', 'size', null, array('size' => 2));
        $msg['color']   =& $this->createElement('text', 'color', null, array('size' => 7));
        $msg['bgcolor'] =& $this->createElement('text', 'bgcolor', null, array('size' => 7));
        $msg['text']    =& $this->createElement('text', 'text', null, array('size' => 30));
        $this->addGroup($msg, 'msg', 'Message (font, size, color, bgcolor, text):', ',&nbsp;');


        $prevnext[] =& $this->createElement('submit', $this->getButtonName('back'), '<< Back');
        $prevnext[] =& $this->createElement('submit', $this->getButtonName('next'), 'Next >>');
        $this->addGroup($prevnext, null, '', '&nbsp;', false);       
    }
}

/**
 *
 */
class Ready extends HTML_QuickForm_Page
{
    function buildForm()
    {
        $this->_formBuilt = true;

        $tabs[] =& $this->createElement('submit', $this->getButtonName('page1'), 'Shape', array('class' => 'flat'));
        $tabs[] =& $this->createElement('submit', $this->getButtonName('page2'), 'Cell', array('class' => 'flat'));
        $tabs[] =& $this->createElement('submit', $this->getButtonName('page3'), 'Text', array('class' => 'flat'));
        $tabs[] =& $this->createElement('submit', $this->getButtonName('page4'), 'Message', array('class' => 'flat'));
        $tabs[] =& $this->createElement('submit', $this->getButtonName('page5'), 'Ready', array('class' => 'flat', 'disabled' => 'disabled'));
        $this->addGroup($tabs, 'tabs', null, '&nbsp;', false);

        $this->addElement('header', null, 'Ready to display progress and get CSS code');

        $color['bg']   =& $this->createElement('text', 'bg', null, array('size' => 7));
        $color['fg']   =& $this->createElement('text', 'fg', null, array('size' => 7));
        $color['link'] =& $this->createElement('text', 'link', null, array('size' => 7));
        $this->addGroup($color, 'color', 'Color (background, foreground, link):', ',&nbsp;');

        $prevnext[] =& $this->createElement('submit', $this->getButtonName('back'), '<< Back');
        $prevnext[] =& $this->createElement('submit', $this->getButtonName('submit'), 'Apply');
        $this->addGroup($prevnext, null, '', '&nbsp;', false);       
    }
}


/**
 *  Class for form rendering
 */
class ActionDisplay extends HTML_QuickForm_Action_Display
{
    function _renderForm(&$page) 
    {
        $renderer =& $page->defaultRenderer();

        $p = new HTML_Page();
        $p->setTitle("PEAR::HTML_Progress - ProgressMaker");
        $p->setMetaData("author", "Laurent Laville");

        $renderer->setFormTemplate('<table class="maintable"><form{attributes}>{content}</form></table>');
        $renderer->setHeaderTemplate('<tr><th colspan="2">{header}</th></tr>');
        $renderer->setGroupTemplate('<table><tr>{content}</tr></table>', 'name');
        $renderer->setGroupElementTemplate('<td>{element}<br /><span style="font-size:10px;"><span class="label">{label}</span></span></td>', 'name');

        $page->accept($renderer);

        $css = new HTML_CSS();
        $css->setStyle('body', 'background-color', '#7B7B88');
        $css->setStyle('body', 'font-family', 'Verdana, Arial, helvetica');
        $css->setStyle('body', 'font-size', '10pt');
        $css->setStyle('h1', 'color', '#FFC');
        $css->setStyle('h1', 'text-align', 'center');
        $css->setStyle('.maintable', 'width', '100%');
        $css->setStyle('.maintable', 'border-width', '0');
        $css->setStyle('.maintable', 'border-style', 'thin dashed');
        $css->setStyle('.maintable', 'border-color', '#D0D0D0');
        $css->setStyle('.maintable', 'background-color', '#EEE');
        $css->setStyle('.maintable', 'cellspacing', '2');
        $css->setStyle('.maintable', 'cellspadding', '3');
        $css->setStyle('th', 'text-align', 'center');
        $css->setStyle('th', 'color', '#FFC');
        $css->setStyle('th', 'background-color', '#AAA');
        $css->setStyle('th', 'white-space', 'nowrap');
        $css->setStyle('input', 'font-family', 'Verdana, Arial, helvetica');
        $css->setStyle('input.flat', 'border-style', 'solid');
        $css->setStyle('input.flat', 'border-width', '2px 2px 0px 2px');
        $css->setStyle('input.flat', 'border-color', '#996');

        $p->addStyleDeclaration($css);
        $p->addBodyContent( '<h1>ProgressMaker - Control Panel</h1>'. $renderer->toHtml() );
	$p->display();
    }
}

class ActionProcess extends HTML_QuickForm_Action
{
    function perform(&$page, $actionName)
    {
        $progress = $page->controller->exportValues();

        $p = new HTML_Page();
        $p->setTitle("PEAR::HTML_Progress - ProgressMaker");
        $p->setMetaData("author", "Laurent Laville");


        $options = array();

        if (strlen(trim($progress['barsize']['width'])) > 0) {
            $options['width'] = $progress['barsize']['width'];
        }
        if (strlen(trim($progress['barsize']['height'])) > 0) {
            $options['height'] = $progress['barsize']['height'];
        }
        if (strlen(trim($progress['barsize']['bgcolor'])) > 0) {
            $options['background-color'] = $progress['barsize']['bgcolor'];
        }

        if (strlen(trim($progress['barborder']['style'])) > 0) {
            $options['border-style'] = $progress['barborder']['style'];
        }
        if (strlen(trim($progress['barborder']['width'])) > 0) {
            $options['border-width'] = $progress['barborder']['width'];
        }
        if (strlen(trim($progress['barborder']['color'])) > 0) {
            $options['border-color'] = $progress['barborder']['color'];
        }

        if (strlen(trim($progress['cellsize']['width'])) > 0) {
            $options['cell-width'] = $progress['cellsize']['width'];
        }
        if (strlen(trim($progress['cellsize']['height'])) > 0) {
            $options['cell-height'] = $progress['cellsize']['height'];
        }
        if (strlen(trim($progress['cellsize']['spacing'])) > 0) {
            $options['cell-spacing'] = $progress['cellsize']['spacing'];
        }
        if (strlen(trim($progress['cellcolor']['active'])) > 0) {
            $options['active-color'] = $progress['cellcolor']['active'];
        }
        if (strlen(trim($progress['cellcolor']['inactive'])) > 0) {
            $options['inactive-color'] = $progress['cellcolor']['inactive'];
        }

        if ($progress['shape'] == HTML_PROGRESS_BAR_HORIZONTAL) {
            include_once 'HTML/Progress/BarHorizontal.php';

            $bar = new HTML_Progress_Bar_Horizontal($progress['way'], $p, $options);
        }
        if ($progress['shape'] == HTML_PROGRESS_BAR_VERTICAL) {
            include_once 'HTML/Progress/BarVertical.php';

            $bar = new HTML_Progress_Bar_Vertical($progress['way'], $p, $options);
        }

        if ($progress['textvisible']) {
            $text['font']             = $progress['text']['font'];
            $text['size']             = $progress['text']['size'];
            $text['color']            = $progress['text']['color'];
            $text['background-color'] = $progress['text']['bgcolor'];
            $text['h-align']          = $progress['texthalign'];
            $text['v-align']          = $progress['textvalign'];
            $text['text']             = $progress['text']['text'];

            if (strlen(trim($progress['textsize']['width'])) > 0) {
                $text['width'] = $progress['textsize']['width'];
            }
            if (strlen(trim($progress['textsize']['height'])) > 0) {
                $text['height'] = $progress['textsize']['height'];
            }
            $bar->setText(true, $text);
        }

        if ($progress['msgvisible']) {
            $message['font']             = $progress['msg']['font'];
            $message['size']             = $progress['msg']['size'];
            $message['color']            = $progress['msg']['color'];
            $message['background-color'] = $progress['msg']['bgcolor'];
            $message['h-align']          = $progress['msghalign'];
            $message['v-align']          = $progress['msgvalign'];
            $bar->setMessageLine(true, $message);
            $bar->setMessage($progress['msg']['text']);
        }

        $css = $bar->getStyle();
        $css1 = $css->toString();
        $css->setStyle('body', 'background-color', $progress['color']['bg']);
        $css->setStyle('body', 'color', $progress['color']['fg']);
        $css->setStyle('body', 'font-family', 'Verdana, Arial');
        $css->setStyle('a:link', 'color', $progress['color']['link']);
        $css->setSameStyle('a:visited, a:active', 'a:link');
        $css->setStyle('div.col1', 'float', 'left');
        $css->setStyle('div.col1', 'width', '25%');
        $css->setStyle('div.col1', 'padding', '1em');
        $css->setStyle('div.col2', 'margin-left', '30%');
        $css->setStyle('div.col2', 'border', '1px solid '.$progress['color']['link']);
        $css->setStyle('div.col2', 'padding', '1em');

        $p->addStyleDeclaration($css);
        $p->addScriptDeclaration( $bar->getScript() );
        $p->addBodyContent('<div class="col1">'.$bar->toHTML().'</div>');
        $p->addBodyContent('<div class="col2">');
        $p->addBodyContent('<h1>ProgressMaker</h1>');
        $p->addBodyContent('<p><i><b>Laurent Laville, September 2003</b></i></p>');
        $p->addBodyContent('<form><textarea readonly="true" name="CSS" wrap="virtual" rows="10" cols="80">');
        $p->addBodyContent($css1);
        $p->addBodyContent('</textarea></form>');
        $p->addBodyContent('</div>');
        $p->display();
        
        // Progress in action ...
        for ($i=0; $i<10; $i++) {
            $bar->display(10);
        }

//        $_SESSION = array();
//        session_destroy();

        echo '<p>&lt;&lt; <a href="'.getenv('SCRIPT_NAME').'">Replay</a></p>';
    }
}

session_start();

$tabbed = new HTML_QuickForm_Controller('Tabbed', false);

$tabbed->addPage(new Property1('page1'));
$tabbed->addPage(new Property2('page2'));
$tabbed->addPage(new Property3('page3'));
$tabbed->addPage(new Property4('page4'));
$tabbed->addPage(new Ready('page5'));

// These actions manage going directly to the pages with the same name
$tabbed->addAction('page1', new HTML_QuickForm_Action_Direct());
$tabbed->addAction('page2', new HTML_QuickForm_Action_Direct());
$tabbed->addAction('page3', new HTML_QuickForm_Action_Direct());
$tabbed->addAction('page4', new HTML_QuickForm_Action_Direct());
$tabbed->addAction('page5', new HTML_QuickForm_Action_Direct());

// We actually add these handlers here for the sake of example
// They can be automatically loaded and added by the controller
$tabbed->addAction('jump', new HTML_QuickForm_Action_Jump());
$tabbed->addAction('submit', new HTML_QuickForm_Action_Submit());

// The customized actions
$tabbed->addAction('display', new ActionDisplay());
$tabbed->addAction('process', new ActionProcess());

$sess = $tabbed->container();
$defaults = $sess['defaults'];

if (count($sess['defaults']) == 0) {
  // ProgressBar default values
  $tabbed->setDefaults(array(
    'shape'        => HTML_PROGRESS_BAR_HORIZONTAL,
    'way'          => 'natural',
    'barsize'      => array('bgcolor' => '#FFFFFF'),

    'cellsize'     => array('width' => 15, 'height' => 20, 'spacing' => 2),
    'cellcolor'    => array('active' => '#006600', 'inactive' => '#CCCCCC'),
    'barborder'    => array('style' => 'solid', 'width' => 0, 'color' => '#000000'),

    'textvisible'  => false,
    'text'         => array('font' => 'Verdana, Arial, Helvetica, sans-serif', 'size' => 12, 'color' => '#000000', 'bgcolor' => '#FFFFFF', 'text' => '%'),
    'textvalign'   => 'right',
    'texthalign'   => 'right',

    'msgvisible'   => false,
    'msg'          => array('font' => 'Verdana, Arial, Helvetica, sans-serif', 'size' => 12, 'color' => '#000000', 'bgcolor' => '#FFFFFF', 'text' => 'progress status ...'),
    'msgvalign'    => 'bottom',
    'msghalign'    => 'left',

    'color'        => array('bg' => '#FFFFFF', 'fg' => '#000000', 'link' => 'navy')
  ));
}

$tabbed->run();

?>
